.\"$Id: crossedit.man,v 1.1 1996/09/03 05:46:47 master Exp $
.TH xledit 0.89.3 "Mar 7 1993"
.SH NAME
xledit - A map-editor for the game Crossfire.
.SH SYNOPSIS
.B xledit
[-debug] [-pix] [-e <map_level> | <height>x<width>]
.SH DESCRIPTION
.PP
.I xtedit
enables you to design maps for the game Crossfire.
.SH OPTIONS
.TP
.B -debug
Enable debug
.TP
.B -pix
Use pixmaps instead of fonts.
.TP
.TP
.B -e
Specify the level of the map to edit after this argument.
Alternatively, if it is a new level, you can specify its size
in the format "<height>x<width>"
.SH DESIGNING MAPS
If you start crossfire with the -e <map-level> option, you will enter
the editor and be allowed to change a map.  If the level you specified
doesn't exist, you will start creating a new (remember to specify the
name of the level before clicking on the save button).
.PP
To change a map, select items from the list of archetypes by moving the
scrollbar with the left and right mouse-button, and then clicking on any
item.  You can also click on any of the backgrounds displayed above
the list of archetypes.  After you have selected something, you can
put it into the map by pressing the left mousebutton.  To put something
on top of another thing, use the right mouse button.
To remove all items on one spot, first choose the background which is
empty (the last one) and then click the left button somewhere on
the map.  If you use the right instead, only the top item will be
deleted.
You can do any of these things repeatedly by holding down the button in
question and move the mouse around.
To scroll the map-window, use the cursor keys or press the middle button
on the mouse while pointing on the scrollbars.
.PP
To save a map, click on the save button.  Check that you have specified
the map-name before doing this (in case you started editing on a new map).
To load another map, just click in the "Level:" button and type in a new
level (followed by return) and then click on the load button.
The width and height of a map can be changed by clicking on the respective
button and typing in a new number (followed by return).  The position that
the players enters the map on can be changed by clicking on either of the
"start" buttons and then clicking someplace on the map.
.PP
To change where an exit-object leads, click on it (after having placed it
on the map) with the middle mouse button.  Then change "Level:", "X:" and "Y:"
by clicking and typing.  If it's level is 0, it automatically leads to
the next level.  If X and Y is 0, the players will start in the default
start positions on the next level.
Some other items can also be edited in the same fashion, like gates, buttons,
handles, holes, teleporters, etc.
.SH FILES
.TP
.B LIBDIR/archetypes
Global objects which can be put on the maps are stored here.
.TP
.B LIBDIR/mapindex
A list of all maps, and their corresponding number is kept here.
.TP
.B LIBDIR/maps/*.om
The files which contains the background of the maps.
.TP
.B LIBDIR/maps/*.oo
The files which contains the objects of the maps.
.TP
.SH SEE ALSO
crossfire
.SH BUGS
Please let me know about any bugs you find in the game.  I know there are
plenty of them, and some are mentioned on the TODO file which is supplied
with the game.
.SH AUTHOR
Copyright (C) 1992 Frank Tore Johansen (frankj@ifi.uio.no)
.PP
Authors and contributors to this program:
.LP
.RS
.ft B
.nf
frankj@ifi.uio.no (Frank Tore Johansen)
kjetilho@ifi.uio.no (Kjetil Torgrim Homme)
tvangod@ecst.csuchico.edu (Tyler)
elmroth@cd.chalmers.se (Tony Elmroth)
dougal.scott@fcit.monasu.edu.au (Dougal Scott)
wchuang@athena.mit.edu (William)
ftww@cs.su.oz.au (Geoff Bailey)
jorgens@flipper.pvv.unit.no (Kjetil Wiekhorst J\(/orgensen)
c.blackwood@rdt.monash.edu.au (Cameron Blackwood)
jtraub+@cmu.edu (Joseph L. Traub)
rgg@aaii.oz.au (Rupert G. Goldie)
eanders+@cmu.edu (Eric A. Anderson)
eneq@Prag.DoCS.UU.SE (Rickard Eneqvist)
Jarkko.Sonninen@lut.fi (Jarkko Sonninen)
kholland@sunlab.cit.cornell.du (Karl Holland)
vick@bern.docs.uu.se (Mikael Lundgren)
mol@meryl.csd.uu.se (Mikael Olsson)
.fi
.ft R
.RE
.LP
.\" This program is free software; you can redistribute it and/or modify
.\" it under the terms of the GNU General Public License as published by
.\" the Free Software Foundation; either version 2 of the License, or
.\" (at your option) any later version.

.\" This program is distributed in the hope that it will be useful,
.\" but WITHOUT ANY WARRANTY; without even the implied warranty of
.\" MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
.\" GNU General Public License for more details.

.\" You should have received a copy of the GNU General Public License
.\" along with this program; if not, write to the Free Software
.\" Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

.\" The author can be reached via e-mail to frankj@ifi.uio.no.
